// example code for simulation and real robot

Main:
  CommPort = 17  // 0 implies simulation, set to your number for Real robot
  gosub InitRobot1
  // write your main program here
  gosub FollowLine
end

FollowLine:
  // very simple line follow algorithm
   while True   
    if rSense()&4
      rturn 1
    else
      rturn -1
    endif
    rForward 1
  wend
return

InitRobot1:
  // CSTEM could provide sample code like this for everyone
  // they could just merge it to the end of their program or
  // open it first to start a new program
  // you can create different routines for different robots
  // in case (for example) some drift differenently from others
  gosub InitExtendedCommands   // sets up variables
  rCommPort CommPort // choose wireless real robot or simulation
  rLocate 410,500   
  rCommand(CalibrateDrift, 0x10) // left wheel faster
  rCommand(SetTurnStyle, 3)
  // place other needed rCommands here
  if CommPort=0
    // perform initialization the sim. needs
    Setcolor green
    linewidth 15
    line 400,500,450,400
    lineto 400,300
    lineto 430,200
    lineto 400,100
    rInvisible green
  else
    // perform initialization the real robot needs 
    // example-initialize the line sensors
    print "Place the robot over a line"
    InLineInputMode ON
    input "Press ENTER when ready",a
    rCommand(CalibrateLineSensors,0)
    print "Move robot to starting location"
    input "Press ENTER when ready",a 
  endif
  // place any initialization here that is for both
  // the simulated or the real robot
return 



InitExtendedCommands:
   // note: many commands are not available on CSTEM 3Pi                 * means Available
   MyTimeOut = 110                 // Sets timeout for 3Pi               * 
                                   // default = 500
   PololuPlay = 111                // argument 1-4 selects               *
                                   // sound to play
   ServoOffset = 112               // default is 0
   CalibrateLineSensors = 113      // argument must be provided,         *
                                   // but not used, sensors
                                   // automatically enabled
   SetRotationTime = 114           // default is 12                      *
   SetMoveTime = 115               // default is 24                      *
   CalibrateDrift = 116            // default is 0 (upper signed         *
                                   // nibble is left wheel
                                   // lower signed nibble is 
                                   // right wheel)
   CalibrateCompass = 117          // argument must be provided, 
                                   // but not used, compass is
                                   // automatically enabled
   SetTurnStyle = 118              // default is 0 (normal               *
                                   // rotational turns)
                                   // numbers from 1-8 will cause
                                   // the SLOW wheel to run at 
                                   // 10 times this % of the
                                   // fast wheel, example, 2
                                   // would make the slow wheel
                                   // 20% of the fast wheel.
   PololuStop = 119                // an argument must be                *
                                   // provided but not used
   ResetDefaults = 120             // an argument must be                *
                                   // provided but not used   
   EnableCompass = 121             // True or false, default True  
                                   // If enabled, compass will be 
                                   // used to augment turns
                                   // and linear travel (typical 
                                   // acurracy, +/- 2 degrees                 
   SetHiLevel = 122                // default is 200, argument           *                   
                                   // passed is HALF of new value
   SetDistMode = 123               //  0 - pixels (default)
                                   //  1 - inches
                                   //  2 - raw data (nonlinear)
   FindBeacon = 124                // argument spec. direction 
                                   // (1-clockwise, 0-counterCW)
   MoveToAngle = 125               // provide 1/2 of the desire 
                                   // angle (0-180)
   SetSpeed = 126                  // Sets speed of remote robot,        *
                                   // default 40
                                   // note: normal rSpeed 
                                   //commands are ignored
 return   
